      subroutine angaprt (b,ch1,ch2,ch3,akf,range,frac)
 
      implicit real*8 (a-h,o-z)
      implicit integer*4 (i-n)
      real*4  range, frac   
      character*3 ch1, ch2, ch3 

c      EQUIVALENCE (AAI,IN),(AAJ,JN),(AAK,KN)
C***********************************************************************
C VERSION 1.0  MPIFR CYBER EDITION  22 MAY 1977.                       *
C SEE NOD 2 MANUAL PAGE G 1.1                                          *
C C.G HASLAM       SEP  1981.                                          *
C H. ANDERNACH     JAN  1984 INCLUDES FRAC=0,1,2 AND RETURNS HOLLERITHS
C THIS ROUTINE CONVERTS THE ANGLE B INTO 3 REALS AI,AJ,AK, FOR DIRECT  *
C PRINTING IN A FORTRAN PRINT STATEMENT. IF B IS IN DEGREES, AI        *
C REPRESENTS DEGREES, AJ MINUTES AND AK SECONDS. IF B IS IN HOURS, AI  *
C REPRESENTS HOURS, AJ MINUTES, AND AK SECONDS. B IS INITIALLY BROUGHT *
C WITHIN THE RANGE 0-RANGE FOR RANGE +VE, OR -RANGE TO +RANGE FOR RANGE*
C -VE. RANGE SHOULD BE EXPRESSED IN UNITS OF B.                        *
C**********************************************************************
C
C  This version created from COMSHIF version, along with I3NUM
C  Antony Schinckel.
C
      Z=B/3600.0 
      IF(RANGE.LT.0.0) GO TO 1 
      RMAX=RANGE  
      RMIN=0.0   
      RADD=RANGE
      GO TO 2   
    1 RMAX=-RANGE   
      RADD=2.0*RMAX
      RMIN=RANGE  
    2 IF(Z.LE.RMAX) GO TO 3  
      Z=Z-RADD   
      GO TO 2  
    3 IF(Z.GE.RMIN) GOTO 4
      Z=Z+RADD   
      GO TO 3   
    4 ROUND=0.000138889
      IF(FRAC.GE.0.5)ROUND=0.0000138889
      IF(FRAC.GE.1.5)ROUND=0.00000138889
C SET ROUND 0.5   SECOND FOR FRAC = 0.0.
C SET ROUND 0.05  SECOND FOR FRAC = 1.0.
C SET ROUND 0.005 SECOND FOR FRAC = 2.0.
      A=ABS(Z)+ROUND
      I=A   
      A=A-I 
      AI=I
      IF(Z.LT.0.0)AI=-AI-0.0001
C SET SIGN OF ANGLE INTO AI INCLUDING -0 CASE.
      A=60.0*ABS(A)  
      J=A  
      AJ=J
      A=A-J 
      AK=60.0*A 
      IF(FRAC.LT.0.5)AK=INT(AK)
C PREVENT APRINT ROUND UP WHEN PRINTING 2,0.
      IF(ABS(FRAC-1.).LT.0.5.AND.AK.GE.0.05)AK=AK-0.05
C PREVENT APRINT ROUND UP WHEN PRINTING 2,1.
      IF(ABS(FRAC-2.).LT.0.5.AND.AK.GE.0.005)AK=AK-0.005
C PREVENT APRINT ROUND UP WHEN PRINTING 2,2.
      AKTOT=AK
C SPLIT AKTOT INTO HOLLERITH A3 INTEGER PART AND REAL FRACT.PART
      RND=10.**(-FRAC)/2.
C RND=.5 (FRAC=0), RND=.05 (FRAC=1), RND=.005 (FRAC=.2)
      IAI=INT(AI)
      IAJ=INT(AJ)
      IAK=INT(AKTOT+RND)
      IRANGE=INT(RANGE)
      IF(B.LT.0.0.AND.IAI.EQ.0)IAI=-100.
c      IN=I3NUM(IAI,IRANGE)
      call i3num (ch1,iai,irange)
c        AI=AAI
c      JN=I3NUM(IAJ,+90)
c      AJ=AAJ
c      KN=I3NUM(IAK,+90)
c      AK=AAK
      call i3num (ch2,iaj,90)
      call i3num (ch3,iak,90)
      AKF=AKTOT-AINT(AKTOT)
      IF(AKF.GE.(1.-RND)) AKF=0.0
c     type *,' ANGAPRT: 1,2,3,akf=',ch1,ch2,ch3,akf
      RETURN
      END
