C *******1*********2*********3*********4*********5*********6*********7**
C
C     Subroutine HMS
C
C     Converts Degrees in Hours-Minutes-Seconds.
C
C     Linux Version: M. Dumke (MPIfR), 14-Jan-2003
C
C     Input:  GRAD double precision  Time in hours.fraction
C             MODE integer           Input in degree (= 0) or hours (=1)
C     Output: IH   integer           Time(1) in hours
C             IM   integer           Time(2) in minutes
C             SEC  double precision  Time(3) in seconds
C
C *******1*********2*********3*********4*********5*********6*********7**
C
      subroutine hms (GRAD,IH,IM,SEC,MODE)
C
      implicit none
      double precision grad, sec, min, hour
      integer ih, im, mode
C
      hour = grad
      if (mode.eq.0) then
        hour = mod(720.d0+hour,360.d0)
        hour = hour/15.d0
      end if
C
      ih = int(hour)
      min = dabs(hour-dble(ih))*60.d0
      im = int(min)
      sec = dabs(min-dble(im))*60.d0
      ih = mod(ih+24,24)
      return
      end
C
C *******1*********2*********3*********4*********5*********6*********7**
