C *******1*********2*********3*********4*********5*********6*********7**
C
C     Program Parang/Paral
C
C     Computes Azm, Elv, etc. for a given source.
C     This main program handles input and output, while the calculations
C        are done within the subroutine Paral.
C
C     Author: H. Andernach (MPIfR), 06-Nov-1985
C
C     Linux Version by M. Dumke (MPIfR), 5-Jan-2003
C
C     Revision History:
C     21-Sep-2004 M. Dumke (ESO): Addition of Equinox to Paral inputline
C      5-Jan-2003 M. Dumke (MPI): Linux version ready
C
C -------1---------2---------3---------4---------5---------6---------7--
C
      program parang
C
      implicit none
      integer i, iday, imon, iyear, ih, min, mode, ntimes, equinox,
     $        nleng, nlin, npage, ndummy, ist, nt1, nt2, isintpl
      integer iiv(8)
      double precision ep(2), premat(3,3), a(3), b(3),
     $                 mjd, stnull, stm, day, dday, epn, tint,
     $                 ellim, rlamda, glat, st, ut, sec, factor,
     $                 pi, rtd, epnow, sl, cl, ra, dec, ra50, dec50,
     $                 st0, stris, stset, rest, frs5, fds5, frs, fds,
     $                 xx, ha, az, azv, el, elv, q, qv
      character*3 rh5,rm5,rs5,dd5,dm5,ds5,rh,rm,rs,dd,dm,ds,sh1,sm1,ss1,
     .            sh2,sm2,ss2,sh,sm,ss
      character*8 cnam
      character ccd*8, cct*10, ccz*5
C
      DATA ELLIM/8.0d0/
C
C     Default:  Koordinaten von Effelsberg: 6d53'0.3" O, 50d31'30" N
C
      rlamda = 6.883416667d0
      glat = 50.525d0
C
C  Initialize temporary output file:
C
      open(20,file='p_out')
c     ***page length for printer output: 62 lines
      nleng = 62
c     ***flag for first source: negative number of lines
      nlin= -1
C
      EP(1)=0.d0
      EP(2)=0.d0
      IST = 0
      PI=ACOS(-1.)  
      RTD=180.d0/PI
C
C  Get current epoch
C
      call date_and_time(ccd,cct,ccz,iiv)
      iyear=iiv(1)
      imon=iiv(2)
      iday=iiv(3)
      epnow = dble(iyear) + dble(imon-1)/12.d0 + dble(iday)/365.d0
C
C  Print Introduction
C
      PRINT 100
  100 FORMAT(/4x,'Program PARAL '//
     .4X,'COMPUTES AZM,ELV AND PAR. ANGLE AND THEIR TIME DERIV''S'/
     .4X,'FOR A FULL VISIBILITY PERIOD FROM any observatory (ELV>5)'/
     .4X,'FOR ANY DESIRED TIME STEP',20X,
     . //'       EXPLANATION OF SYMBOLS:'//
     .4X,'RISE: TIME WHEN ELV=8 DEGS IS REACHED  AFTER MATH. RISE'/
     .5X,'SET: TIME WHEN ELV=8 DEGS IS REACHED BEFORE MATH. SET'/
     .5X,'LST: LOCAL SID. TIME (HR,MIN,SEC)'/5X,' HA: HOUR ANGLE (HRS)'/
     .5X,'AZM,ELV,PARANG: AZIMUTH, ELEVATION, PARALLACTIC ANGLE (DEGS)'/
     .5X,'AZVAR,ELVAR,PAVAR: TIME DERIV''S OF ABOVE PARAMETERS (DEG)'/
     .5X,'EXCSI IS HELPFUL PLANNING MULTIBEAM BOLOMETER OBSERVATIONS :'
     .//8X,'EXCSI*(SDST/30''*SDST/30''/VAZM/30''/MIN)) ='//
     .              30X,'DISTANCE('''') BETWEEN ENDPOINTS OF ADJACENT'/
     .              30X,'AZM-SUBSCANS IN EXCESS OF SINT '//
     .8X,'AT TIMES WHEN SINT+EXCSI > HPBW/2.5  EITHER DECREASE SINT'/
     .8x,' SUSPEND OBSERVATIONS FOR SOME TIME.'/
     .4x,'Output will be on file "p_out".')
c
c possibility to calculate for desired latitute of telescope (HPR)
c
    1 print*,' '
      print*,' Latitude of observer: ("/" = ',glat,')'
      print*,' "end" = Stop'
      read(5,*,err=777)GLAT
      print*,' '
      print*,' '
      print*,' Longitude of observer: ("/" = ',rlamda,')'
      read(5,*,err=777)rlamda
      print*,' '
c
      print 201
  201 format(/'   Now enter for one or more sources:'/
     .3X,'Name(A8), RA, DEC, Equinox, Epoch, Time step (minutes)'/
     .3X,'Defaults are: 2000, Epoch = TODAY, Time step = 30 minutes.'/)
      print 2001
 2001 format('   Format for epoch = iyear.imonthiday, e.g.',
     .' 2001.1231 = 31.12.2001',/)
C
C  Read in source parameters with new subroutine READLINE
C
 2003 call readline(cnam,ra50,dec50,equinox,ep,ist)
C
C  Convert RA into degrees:
C
      ra50 = ra50*15.
c
      SL=SIN(GLAT/RTD)   
      CL=COS(GLAT/RTD)
c
      IF(IST.NE.0) then
        write(*,*) ' There was an error in the input. Try it again!'
        goto 2003
      end if
C
c     *** new page if not first source
      if (nlin.gt.0)then
c        *** skip lines until page break
         nlin=nlin+1
         do 204 i=nlin,nleng
            write(20,*)
  204    end do
      endif
      npage=1
      nlin=0
c     ***print page no
      call pgprt(npage,nlin)
C
C  Decode epoche=iyear.imon.iday, e.g. 2003.0316 = 16 Mar 2003
C    If epoche = 0, then take current date.
C
      epn = ep(1)
      tint = ep(2)
      if (tint.EQ.0.d0) tint = 30.d0
      if (epn.NE.0.d0) then
        iyear = int(epn)
        rest = (epn-dble(iyear))*100.d0
        imon = int(rest)
        rest = (rest-dble(imon))*100.d0
C  Add 1.d-6 (= 0.0864 seconds) because of rounding error:
        iday = int(rest+1.d-6)
        epn = dble(iyear) + dble(imon-1)/12.d0 + dble(iday)/365.d0
      else
        epn = epnow
      end if
      day = dble(iday)
C
C  Calculate the LST for 0 UT, 6 UT, 12 UT and 18 UT:
C
      call modjuldat(day,imon,iyear,mjd)
      call mjd2st(mjd,rlamda,st0,stnull)
      mode=1
      call hms(stnull,ih,min,sec,mode)
      if (ih.gt.23) ih=ih-24
      write(*,*)'lst at  0h ut =',ih,' h ',min,' m ',sec,' s'
C
      dday=day+0.25d0
      call modjuldat(dday,imon,iyear,mjd)
      call mjd2st(mjd,rlamda,st0,stm)
      mode=1
      call hms(stm,ih,min,sec,mode)
      if (ih.gt.23) ih=ih-24
      write(*,*)'lst at  6h ut =',ih,' h ',min,' m ',sec,' s'
C
      dday=day+0.5d0
      call modjuldat(dday,imon,iyear,mjd)
      call mjd2st(mjd,rlamda,st0,stm)
      mode=1
      call hms(stm,ih,min,sec,mode)
      if (ih.gt.23) ih=ih-24
      write(*,*)'lst at 12h ut =',ih,' h ',min,' m ',sec,' s'
C
      dday=day+0.75d0
      call modjuldat(dday,imon,iyear,mjd)
      call mjd2st(mjd,rlamda,st0,stm)
      mode=1
      call hms(stm,ih,min,sec,mode)
      if (ih.gt.23) ih=ih-24
      write(*,*)'lst at 18h ut =',ih,' h ',min,' m ',sec,' s'
C
      RA=RA50  
      DEC=DEC50  

      if (real(epn).NE.2000.0) then
        if (equinox.EQ.1950) then
          call sla_precl(1950.0D0,epn,premat)
        else
          call sla_precl(2000.0D0,epn,premat)
        end if
        CALL DCOSIN(RA50,DEC50,A)
        CALL sla_dmxv(premat,A,B)
        CALL DANGLE(RA,DEC,B)
      end if
      IF(DEC.LE.(-90.+ELLIM+GLAT)) GOTO 778
      CALL RISESET(RA,DEC,GLAT,ELLIM,STRIS,STSET)
      CALL ANGAPRT(240.0*RA50,RH5,RM5,RS5,FRS5,+24.0,1.0)
      CALL ANGAPRT(3600.*DEC50,DD5,DM5,DS5,FDS5,-90.0,1.0)
      CALL ANGAPRT(240.00d0*RA,RH,RM,RS,FRS,+24.0,1.0)
      CALL ANGAPRT(3600.*DEC,DD,DM,DS,FDS,-90.0,1.0)
      CALL ANGAPRT(3600.*STRIS,SH1,SM1,SS1,XX,+24.0,0.0)
      CALL ANGAPRT(3600.*STSET,SH2,SM2,SS2,XX,+24.0,0.0)
      IF(STSET.LT.STRIS)STSET=STSET+24.0
C
C  Handle single time (DEC.HRS) request for calculation:
C
      if (tint.lt.0.d0) then
        st = abs(tint)
        tint = 0.d0
        ntimes = 1
      else
        tint = tint / 60.d0
        nt1 = int(stris/tint) + 1
        nt2 = int(stset/tint)
        ntimes = nt2 - nt1 + 1 
        st = dble(nt1) * tint
      end if
C
      rlamda=mod(rlamda,360.)
      if (rlamda.ge.180.0) rlamda=rlamda-360.0
      write(20,104)  rlamda,CNAM,RH5,RM5,RS5,FRS5,EPN,RH,RM,RS,FRS,
     .SH1,SM1,SS1,iday,imon,iyear,
     .DD5,DM5,DS5,FDS5,EPN,DD,DM,DS,FDS,
     .SH2,SM2,SS2,glat
      nlin=nlin+5
      if (equinox.EQ.1950) then
        write(6,104) rlamda, CNAM,RH5,RM5,RS5,FRS5,EPN,RH,RM,RS,FRS,
     .               SH1,SM1,SS1,iday,imon,iyear,
     .               DD5,DM5,DS5,FDS5,EPN,DD,DM,DS,FDS,
     .               SH2,SM2,SS2,GLAT
      else
        write(6,105) rlamda, CNAM,RH5,RM5,RS5,FRS5,EPN,RH,RM,RS,FRS,
     .               SH1,SM1,SS1,iday,imon,iyear,
     .               DD5,DM5,DS5,FDS5,EPN,DD,DM,DS,FDS,
     .               SH2,SM2,SS2,GLAT

      end if
  104 FORMAT(1X,20('-'),
     .      ' LONGITUDE OF OBSERVER: ',F12.7,' ',20('-')
     .      /3X,A8,4X,'RA1950=',3A3,F2.1,4X,'RA',F7.2,'=',
     .      3A3,F2.1,4X,'RISE',3A3/,
     .      2x,i2,'.',i2,'.',i4,2X,'DEC1950=',3A3,F2.1,3X,'DEC',
     .      F7.2,'=',3A3,F2.1,5X,'SET',3A3/1X,20('-'),
     .      ' LATITUDE OF OBSERVER:  ',F12.8,' ',20('-')/)
  105 FORMAT(1X,20('-'),
     .      ' LONGITUDE OF OBSERVER: ',F12.7,' ',20('-')
     .      /3X,A8,4X,'RA2000=',3A3,F2.1,4X,'RA',F7.2,'=',
     .      3A3,F2.1,4X,'RISE',3A3/,
     .      2x,i2,'.',i2,'.',i4,2X,'DEC2000=',3A3,F2.1,3X,'DEC',
     .      F7.2,'=',3A3,F2.1,5X,'SET',3A3/1X,20('-'),
     .      ' LATITUDE OF OBSERVER:  ',F12.8,' ',20('-')/)
      IF(NTIMES.LE.0)GOTO 779  
      call headline(20,nlin)
      ndummy=0
      call headline(6,ndummy)
      factor=ep(2)/60.d0
      do i=1,ntimes
        call paral (RA,DEC,GLAT,ST,HA,AZ,AZV,EL,ELV,Q,QV)
C
C  The sign of parallactic angle depends on the definition:
C
        q= -q
        qv= -qv
        CALL ANGAPRT(3600.*ST,SH,SM,SS,XX,24.0,0.0)
        ISINTPL = ABS(NINT(30.d0*QV*1.15d0/RTD))
C
C  AzV, ElV, and QV are in degrees/hour, but should be in degrees/time step
C
        azv=azv*factor
        elv=elv*factor
        qv=qv*factor
C
        ut = st
        ut = ut - stnull
        ut = ut/1.00273790935d0
        ut = mod(ut+24.d0,24.d0)
         
        call hms(ut,ih,min,sec,mode)
        write(20,106)SH,SM,SS,HA,AZ,AZV,EL,ELV,Q,QV,ISINTPL,ih,min,sec
        write(6,106)SH,SM,SS,HA,AZ,AZV,EL,ELV,Q,QV,ISINTPL,ih,min,sec
  106   FORMAT(2X,3A3,F7.2,F8.1,F6.1,F8.1,F6.1,F9.1,F6.1,I5,1X,2i3,f4.0)
        nlin=nlin+1
        if(nlin.eq.nleng)then
          call newpage(npage,nlin)
        endif
        st = st + tint
      end do
      GOTO 1
  778 PRINT*,' SORRY, SOURCE IS TOO FAR SOUTH! TRY ANOTHER ONE:'
      GOTO 1
  779 PRINT*,' NO MULTIPLE OF THE TIME STEP WITHIN VISIBILITY RANGE!'
      GOTO 1
  777 stop
      END
C
C *******1*********2*********3*********4*********5*********6*********7**
